
{
   Copyright (c) 2002 by Adam Boduch
}

unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

{ deklaracja komunikatw, ktre przesyane bd pomidzy DLL'em a aplikacj }

const WM_THREADBEGIN = WM_USER + 1100;
      WM_THREADEND = WM_USER + 1110;

type
  TMainForm = class(TForm)
    btnLoadLibrary: TButton;
    btnFreeLibrary: TButton;
    BitBtn1: TBitBtn;
    lblMsg: TLabel;
    procedure btnLoadLibraryClick(Sender: TObject);
    procedure btnFreeLibraryClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
  { a oto procedury, ktre obsugiwa bd dane komunikaty }
    procedure WMThreadBegin(var Msg : TMessage); message WM_THREADBEGIN;
    procedure WmThreadEnd(var Msg : TMessage); message WM_THREADEND;
  end;

{ jaki przykadowy wtek }
  TSomeThread = class(TThread)
  protected
    procedure Execute; override;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

var LibHandle : THandle; // uchwyt zaadowanej biblioteki

procedure TMainForm.btnLoadLibraryClick(Sender: TObject);
begin
{ bibliotek mona zaadowa tylko raz - jeeli warto jest pusta ( 0 ) }
  if LibHandle = 0 then
    LibHandle := LoadLibrary('DLL.dll'); // zaaduj bibliotek
end;

procedure TMainForm.btnFreeLibraryClick(Sender: TObject);
begin
  if LibHandle <> 0 then
  begin
  { jeeli warto LibHandle jest rna od zera to znaczy, e biblioteka jest zaadowana
    i naley (mona) teraz j zwolni }
    FreeLibrary(LibHandle);
    LibHandle := 0; // przypisz warto 0
  end;
end;

{ TSomeThread }

procedure TSomeThread.Execute;
begin
  FreeOnTerminate := True;
  { jakie okienko }
  MessageBox(Handle, 'Odpalamy wtek...', '', MB_OK);
  Sleep(5000); // czekaj 5 sek.
end;

procedure TMainForm.WMThreadBegin(var Msg: TMessage);
begin
{ w momencie odebrania komunikatu wywietl na etykiecie informacje }
  lblMsg.Caption := 'Biblioteka DLL mwi: "Wiem, e odpalie jaki wtek..."';
end;

procedure TMainForm.WmThreadEnd(var Msg: TMessage);
begin
{ w momencie odebrania komunikatu wywietl na etykiecie informacje }
  lblMsg.Caption := 'Biblioteka DLL mwi: "Wiem, e zakoczye jaki wtek..."';
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
begin
{ uruchom wtek }
  TSomeThread.Create(False);
end;

end.
