
program Demo;

uses Windows, Messages;


const
  AppName : PChar = 'Przykadowy program do odtwarzania muzyki MID i WAV'; // Caption dla formy

{  Wykorzystalem tutaj ladowanie statyczne z bibliotek DLL. Oto funkcje zaimportowane
   wlasnie z DLL-i.
}
 procedure Open(const AFileName : PChar; _HWND : HWND); stdcall external 'mid.dll' name 'Open';
 procedure Play; stdcall external 'mid.dll' name 'Play';
 procedure Stop; stdcall external 'mid.dll' name 'Stop';
 function Length : Integer; stdcall external 'mid.dll' name 'Length';

var
  Msg : TMsg;
  WND : HWND;
  Button : array[0..1] of  HWND;
  Edit : HWND;
  Font1 : Integer;
  Buff : array[0..255] of Char;

const
  btnPlay = 101;
  btnStop = 102;

(*************************************************************************)

function Okno(H : HWND; Msg: UINT; wPar : WPARAM; lPar: LPARAM):
  LRESULT; stdcall;
begin
  Result := 0;
  case Msg of

    WM_CREATE:
      begin
        Font1 := CreateFont( // utworz czcionke dla przyszlych komponentow
        16,0,0,0,FW_NORMAL,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,'MS Sans Serif');

        SendMessage(CreateWindow('STATIC', 'Wpisz ciek do pliku muzycznego', WS_VISIBLE or WS_CHILD,
        60, 20, 220, 25, H, 0, hInstance, nil), WM_SETFONT, Font1, 0); // utworz Label'a i nadaj mu czionke

        Edit := CreateWindow('EDIT', 'C:\plik.mid', WS_CHILD or WS_VISIBLE or WS_BORDER, 10, 50, 270, 20, H, 0, hInstance, nil);
        SendMessage(Edit, WM_SETFONT, Font1, 0);  // stworz komponent Edit

    { Stworz dwa buttony do odtwarzania i do zatrzymywania utworu }
        Button[0] := CreateWindow('BUTTON', 'Graj', WS_CHILD or WS_VISIBLE, 100, 100, 120, 25, H, btnPlay, hInstance, nil);
        Button[1] := CreateWindow('BUTTON', 'Stop', WS_CHILD or WS_VISIBLE, 100, 150, 120, 25, H, btnStop, hInstance, nil);
      end;

    WM_COMMAND:
      begin
        case wPar of
          btnPlay: // w przypadku nacisniecia na przycisk Graj wykonana zostanie ponizsza procedura:
          begin
            GetWindowText(Edit, Buff, SizeOf(Buff)); // pobierz tekst z komponentu Edit
            Open(Buff, H);  // wywolaj procedure
            Play;  // oderaj plik dzwiekowy
          end;
          
          btnStop: // w przypadku, gdy uzytwkonik bedzie chcial zatrzymac odtwarzanie utworu...
            Stop; // wywolaj procedure zatrzymujaca
                        
        end;
      end;

    WM_DESTROY: PostQuitMessage(0);
  else
    Result := DefWindowProc(H, Msg, wPar, lPar);
  end;
end;

procedure InitApp;
var
  WNDCLASS : TWndClass;
begin
  WndClass.style := CS_CLASSDC; // styl okna
  WndClass.lpfnWndProc := @Okno; // adres funkcji okienkowej
  WndClass.cbClsExtra := 0;
  WndClass.cbWndExtra := 0;
  WndClass.hInstance := hInstance; // zasoby
  WndClass.hIcon := LoadIcon(0, IDI_APPLICATION); // ikona
  WndClass.hCursor := LoadCursor(0, IDC_ARROW); // kursor
  WndClass.hbrBackground := COLOR_WINDOW; // kolor tla
  WndClass.lpszMenuName := nil;
  WndClass.lpszClassName := AppName; // nazwa ("Caption")


  Windows.RegisterClass(WNDCLASS); // rejestracja klasy

  Wnd := CreateWindow(AppName,  // stworz okno
  AppName,
  WS_SYSMENU,
  120, // x
  120, // y
  300, // width
  270, // height
  0, 0,
  hInstance, nil);
    ShowWindow(wnd, SW_SHOW); // pokaz okno

end;

begin
  InitApp;  // wywolaj procedure

  while GetMessage(msg, 0, 0, 0) do // petla komunikatow
  begin
     TranslateMessage(msg);
     DispatchMessage(msg);
  end;
  Halt(msg.wParam);
end.

